%{
/*****************************************************************************/
/*FILE: HAL_LEX.L	Lexical Analyzer (use with FLEX or LEX)		     */
/*****************************************************************************
	Copyright (c) 1992
	Digital Equipment Corporation, Maynard, Massachusetts 01754

	The HAL Alpha Assembler is free software; you can redistribute 
	it and/or modify it with the sole restriction that this copyright 
	notice be attached.

	The information in this software is subject to change without notice 
	and should not be construed as a commitment by Digital Equipment
	Corporation.

	The author disclaims all warranties with regard to this software,
	including all implied warranties of merchantability and fitness, in
	no event shall he be liable for any special, indirect or consequential
	damages or any damages whatsoever resulting from loss of use, data, 
	or profits, whether in an action of contract, negligence or other
	tortious action, arising out of or in connection with the use or
	performance of this software.
 *****************************************************************************/
/* Originally Created by: Homayoon Akhiani	April,1992		     */
/*****************************************************************************
! REVISION HISTORY:
! Who   When            What
!---------------------------------------------------------------
! HA	16-Jul-1992	HW_LD,HW_ST handling
! HA	12-May-1992	Handle /p and /d 
! HA	07-May-1992	.BLKL and .BLKQ
! HA	06-May-1992	Some people use LDG
! HA	01-May-1992	Add more misc. RPCC, FETCH,...
! HA    23-Apr-1992	Include stdlib.h (for portability)    
! HA	17-Apr-1992	PAL_Rx added, OR added(it is not in SRM)
! HA    xx-Apr-1992     First pass
 *****************************************************************************/
/*****************************************************************************/
#ifdef THINK_C
#include <stdlib.h>
#endif
#include <string.h>
#include "alpha_opcode.h"
#include "hal.h"
#ifndef VMS
#include "hal_parser.tab.h"
#else
#include "HAL_PARSER_TAB.H"
#endif
extern B32	Opc;
extern B32	R[2];
extern int	Reg;
extern int      line_number;
extern char	Sym[];
int		ret;
int		tn;			/*Temporary number*/			
%}
ALPHA	[A-Za-z$%_]
ALPN	[A-Za-z0-9$%_]
HEXD    [0-9A-Fa-f]
DECD	[0-9]
REGN	{DECD}{1,2}
REGNAME [FR]{REGN}
PALREG  [P]{REGN}
WS	[ \t\014]+
NUM	[^][xX]
SYMBOL	{ALPN}+
COMT    [;][^\n]*
%%
"pal_r"{REGN}   {sscanf(yytext,"%*5c%d",&tn);R[0]=IPR_PAL|tn;it(yytext);return(IPRS);}
{PALREG}        {sscanf(yytext,"%*c%d",&tn);R[0]=IPR_PAL|tn;it(yytext);return(IPRS);}
{REGNAME}	{sscanf(yytext,"%*c%d",&Reg); it(yytext);return(REG);}
{NUM}{HEXD}+	{ ret = scan64h(yytext); it(yytext);return(ret);}
{DECD}+		{ sscanf(yytext,"%d",&R[0]); it(yytext);return(IMMED);}
".psect"[^\n]*  {}
".title"[^\n]*  {}
".align"	{ it(yytext);return(ALIGN); }
".blkl"		{ it(yytext);return(BLKL); }
".blkq"		{ it(yytext);return(BLKQ); }
".address"	{ it(yytext);return(ADDR); }
".quad"		{ it(yytext);return(QUAD); }
".long"		{ it(yytext);return(LONG); }
".end"		{ it(yytext);return(ENDP); }

EXC_ADDR	{R[0]=IPR_EXC_ADDR;it(yytext);return(IPRS);} 
DTB_CTL		{R[0]=IPR_DTB_CTL;it(yytext);return(IPRS);}
DTB_PTE		{R[0]=IPR_DTB_PTE;it(yytext);return(IPRS);}
DPTE_TEMP	{R[0]=IPR_DPTE_TEMP;it(yytext);return(IPRS);}
MM_CSR		{R[0]=IPR_MM_CSR;it(yytext);return(IPRS);}
VA		{R[0]=IPR_VA;it(yytext);return(IPRS);}
ITBZAP		{R[0]=IPR_ITBZAP;it(yytext);return(IPRS);}
DTBZAP		{R[0]=IPR_DTBZAP;it(yytext);return(IPRS);}
ITBASM		{R[0]=IPR_ITBASM;it(yytext);return(IPRS);}
DTBASM		{R[0]=IPR_DTBASM;it(yytext);return(IPRS);}
ITBIS		{R[0]=IPR_ITBIS;it(yytext);return(IPRS);}
DTBIS		{R[0]=IPR_DTBIS;it(yytext);return(IPRS);}
BIU_STAT	{R[0]=IPR_BIU_STAT;it(yytext);return(IPRS);}
DC_ADDR		{R[0]=IPR_DC_ADDR;it(yytext);return(IPRS);}
DC_STAT		{R[0]=IPR_DC_STAT;it(yytext);return(IPRS);}
FILL_ADDR	{R[0]=IPR_FILL_ADDR;it(yytext);return(IPRS);}
ABOX_CTL	{R[0]=IPR_ABOX_CTL;it(yytext);return(IPRS);}
ALT_MODE	{R[0]=IPR_ALT_MODE;it(yytext);return(IPRS);}
CC		{R[0]=IPR_CC;it(yytext);return(IPRS);}
CC_CTL		{R[0]=IPR_CC_CTL;it(yytext);return(IPRS);}
BIU_CTL		{R[0]=IPR_BIU_CTL;it(yytext);return(IPRS);}
FILL_SYNDROME	{R[0]=IPR_FILL_SYNDROME;it(yytext);return(IPRS);}
BC_TAG		{R[0]=IPR_BC_TAG;it(yytext);return(IPRS);}
FLUSH_IC	{R[0]=IPR_FLUSH_IC;it(yytext);return(IPRS);}
INTR_FLAG	{R[0]=IPR_INTR_FLAG;it(yytext);return(IPRS);}
LOCK_FLAG	{R[0]=IPR_LOCK_FLAG;it(yytext);return(IPRS);}
TB_TAG		{R[0]=IPR_TB_TAG;it(yytext);return(IPRS);}
ITB_PTE		{R[0]=IPR_ITB_PTE;it(yytext);return(IPRS);}
ICCSR		{R[0]=IPR_ICCSR;it(yytext);return(IPRS);}
IPTE_TEMP	{R[0]=IPR_IPTE_TEMP;it(yytext);return(IPRS);}
EXC_ADDR	{R[0]=IPR_EXC_ADDR;it(yytext);return(IPRS);}
SL_RCV		{R[0]=IPR_SL_RCV;it(yytext);return(IPRS);}
PS		{R[0]=IPR_PS;it(yytext);return(IPRS);}
EXC_SUM		{R[0]=IPR_EXC_SUM;it(yytext);return(IPRS);}
PAL_BASE	{R[0]=IPR_PAL_BASE;it(yytext);return(IPRS);}
HIRR	{R[0]=IPR_HIRR;it(yytext);return(IPRS);}
SIRR	{R[0]=IPR_SIRR;it(yytext);return(IPRS);}
ASTRR	{R[0]=IPR_ASTRR;it(yytext);return(IPRS);}
HIER	{R[0]=IPR_HIER;it(yytext);return(IPRS);}
SIER	{R[0]=IPR_SIER;it(yytext);return(IPRS);}
ASTER	{R[0]=IPR_ASTER;it(yytext);return(IPRS);}
SL_CLR	{R[0]=IPR_SL_CLR;it(yytext);return(IPRS);}
SL_XMIT	{R[0]=IPR_SL_XMIT;it(yytext);return(IPRS);}
ISSUE_CHK	{R[0]=IPR_ISSUE_CHK;it(yytext);return(IPRS);}
SINGLE_ISSUE	{R[0]=IPR_SINGLE_ISSUE;it(yytext);return(IPRS);}
DUAL_ISSUE	{R[0]=IPR_DUAL_ISSUE;it(yytext);return(IPRS);}

LDL		{ Opc= OPC32_LDL;	it(yytext);return(INS_MEM);}
LDQ		{ Opc= OPC32_LDQ;	it(yytext);return(INS_MEM);}
LDLL		{ Opc= OPC32_LDLL;	it(yytext);return(INS_MEM);}
LDQL		{ Opc= OPC32_LDQL;	it(yytext);return(INS_MEM);}
LDQU		{ Opc= OPC32_LDQU;	it(yytext);return(INS_MEM);}
LDA		{ Opc= OPC32_LDA;	it(yytext);return(INS_MEM);}
STL		{ Opc= OPC32_STL;	it(yytext);return(INS_MEM);}
STQ		{ Opc= OPC32_STQ;	it(yytext);return(INS_MEM);}
STLC		{ Opc= OPC32_STLC;	it(yytext);return(INS_MEM);}
STQC		{ Opc= OPC32_STQC;	it(yytext);return(INS_MEM);}
STQU		{ Opc= OPC32_STQU;	it(yytext);return(INS_MEM);}
LDAH		{ Opc= OPC32_LDAH;	it(yytext);return(INS_MEM);}
LDF		{ Opc= OPC32_LDF;	it(yytext);return(INS_MEM);}
LDD		{ Opc= OPC32_LDD;	it(yytext);return(INS_MEM);}
LDG		{ Opc= OPC32_LDD;	it(yytext);return(INS_MEM);}
LDS		{ Opc= OPC32_LDS;	it(yytext);return(INS_MEM);}
LDT		{ Opc= OPC32_LDT;	it(yytext);return(INS_MEM);}
STF		{ Opc= OPC32_STF;	it(yytext);return(INS_MEM);}
STD		{ Opc= OPC32_STD;	it(yytext);return(INS_MEM);}
STG		{ Opc= OPC32_STD;	it(yytext);return(INS_MEM);}
STS		{ Opc= OPC32_STS;	it(yytext);return(INS_MEM);}
STT		{ Opc= OPC32_STT;	it(yytext);return(INS_MEM);}

ADDL		{ Opc= OPC32_ADDL;	it(yytext);return(INS_IOP);}
ADDLV		{ Opc= OPC32_ADDLV;	it(yytext);return(INS_IOP);}
ADDQ		{ Opc= OPC32_ADDQ;	it(yytext);return(INS_IOP);}
ADDQV		{ Opc= OPC32_ADDQV;	it(yytext);return(INS_IOP);}
S4ADDL		{ Opc= OPC32_S4ADDL;	it(yytext);return(INS_IOP);}
S4ADDQ		{ Opc= OPC32_S4ADDQ;	it(yytext);return(INS_IOP);}
S8ADDL		{ Opc= OPC32_S8ADDL;	it(yytext);return(INS_IOP);}
S8ADDQ		{ Opc= OPC32_S8ADDQ;	it(yytext);return(INS_IOP);}
S4SUBL		{ Opc= OPC32_S4SUBL;	it(yytext);return(INS_IOP);}
S4SUBQ		{ Opc= OPC32_S4SUBQ;	it(yytext);return(INS_IOP);}
S8SUBL		{ Opc= OPC32_S8SUBL;	it(yytext);return(INS_IOP);}
S8SUBQ		{ Opc= OPC32_S8SUBQ;	it(yytext);return(INS_IOP);}
SUBL		{ Opc= OPC32_SUBL;	it(yytext);return(INS_IOP);}
SUBLV		{ Opc= OPC32_SUBLV;	it(yytext);return(INS_IOP);}
SUBQ		{ Opc= OPC32_SUBQ;	it(yytext);return(INS_IOP);}
SUBQV		{ Opc= OPC32_SUBQV;	it(yytext);return(INS_IOP);}
CMPEQ		{ Opc= OPC32_CMPEQ;	it(yytext);return(INS_IOP);}
CMPLT		{ Opc= OPC32_CMPLT;	it(yytext);return(INS_IOP);}
CMPLE		{ Opc= OPC32_CMPLE;	it(yytext);return(INS_IOP);}
CMPULT		{ Opc= OPC32_CMPULT;	it(yytext);return(INS_IOP);}
CMPULE		{ Opc= OPC32_CMPULE;	it(yytext);return(INS_IOP);}
CMPBGE		{ Opc= OPC32_CMPBGE;	it(yytext);return(INS_IOP);}
AND		{ Opc= OPC32_AND;	it(yytext);return(INS_IOP);}
BIC		{ Opc= OPC32_BIC;	it(yytext);return(INS_IOP);}
CMOVEQ		{ Opc= OPC32_CMOVEQ;	it(yytext);return(INS_IOP);}
CMOVNE		{ Opc= OPC32_CMOVNE;	it(yytext);return(INS_IOP);}

ORNOT		{ Opc= OPC32_ORNOT;	it(yytext);return(INS_IOP);}

BIS		{ Opc= OPC32_BIS;	it(yytext);return(INS_IOP);}
OR		{ Opc= OPC32_BIS;	it(yytext);return(INS_IOP);}

CMOVLT		{ Opc= OPC32_CMOVLT;	it(yytext);return(INS_IOP);}
CMOVGE		{ Opc= OPC32_CMOVGE;	it(yytext);return(INS_IOP);}
XOR		{ Opc= OPC32_XOR;	it(yytext);return(INS_IOP);}
EQV		{ Opc= OPC32_EQV;	it(yytext);return(INS_IOP);}
CMOVLE		{ Opc= OPC32_CMOVLE;	it(yytext);return(INS_IOP);}
CMOVGT		{ Opc= OPC32_CMOVGT;	it(yytext);return(INS_IOP);}
CMOVLBS		{ Opc= OPC32_CMOVLBS;	it(yytext);return(INS_IOP);}
CMOVLBC		{ Opc= OPC32_CMOVLBC;	it(yytext);return(INS_IOP);}
EXTBL		{ Opc= OPC32_EXTBL;	it(yytext);return(INS_IOP);}
EXTWL		{ Opc= OPC32_EXTWL;	it(yytext);return(INS_IOP);}
EXTLL		{ Opc= OPC32_EXTLL;	it(yytext);return(INS_IOP);}
EXTQL		{ Opc= OPC32_EXTQL;	it(yytext);return(INS_IOP);}
EXTWH		{ Opc= OPC32_EXTWH;	it(yytext);return(INS_IOP);}
EXTLH		{ Opc= OPC32_EXTLH;	it(yytext);return(INS_IOP);}
EXTQH		{ Opc= OPC32_EXTQH;	it(yytext);return(INS_IOP);}
INSBL		{ Opc= OPC32_INSBL;	it(yytext);return(INS_IOP);}
INSWL		{ Opc= OPC32_INSWL;	it(yytext);return(INS_IOP);}
INSLL		{ Opc= OPC32_INSLL;	it(yytext);return(INS_IOP);}
INSQL		{ Opc= OPC32_INSQL;	it(yytext);return(INS_IOP);}
INSWH		{ Opc= OPC32_INSWH;	it(yytext);return(INS_IOP);}
INSLH		{ Opc= OPC32_INSLH;	it(yytext);return(INS_IOP);}
INSQH		{ Opc= OPC32_INSQH;	it(yytext);return(INS_IOP);}
MSKBL		{ Opc= OPC32_MSKBL;	it(yytext);return(INS_IOP);}
MSKWL		{ Opc= OPC32_MSKWL;	it(yytext);return(INS_IOP);}
MSKLL		{ Opc= OPC32_MSKLL;	it(yytext);return(INS_IOP);}
MSKQL		{ Opc= OPC32_MSKQL;	it(yytext);return(INS_IOP);}
MSKWH		{ Opc= OPC32_MSKWH;	it(yytext);return(INS_IOP);}
MSKLH		{ Opc= OPC32_MSKLH;	it(yytext);return(INS_IOP);}
MSKQH		{ Opc= OPC32_MSKQH;	it(yytext);return(INS_IOP);}
ZAP		{ Opc= OPC32_ZAP;	it(yytext);return(INS_IOP);}
ZAPNOT		{ Opc= OPC32_ZAPNOT;	it(yytext);return(INS_IOP);}
SRA		{ Opc= OPC32_SRA;	it(yytext);return(INS_IOP);}
SRL		{ Opc= OPC32_SRL;	it(yytext);return(INS_IOP);}
SLL		{ Opc= OPC32_SLL;	it(yytext);return(INS_IOP);}
MULL		{ Opc= OPC32_MULL;	it(yytext);return(INS_IOP);}
MULQV		{ Opc= OPC32_MULQV;	it(yytext);return(INS_IOP);}
MULLV		{ Opc= OPC32_MULLV;	it(yytext);return(INS_IOP);}
UMULH		{ Opc= OPC32_UMULH;	it(yytext);return(INS_IOP);}
MULQ		{ Opc= OPC32_MULQ;	it(yytext);return(INS_IOP);}

JMP		{ Opc= OPC32_JMP;	it(yytext);return(INS_MEM);}
JSR		{ Opc= OPC32_JSR;	it(yytext);return(INS_MEM);}
RET		{ Opc= OPC32_RET;	it(yytext);return(INS_MEM);}
JSR_COROUTINE	{ Opc= OPC32_JSR_COROUTINE;	it(yytext);return(INS_MEM);}

BR		{ Opc= OPC32_BR;		it(yytext);return(INS_BRN);}
BSR		{ Opc= OPC32_BSR;	it(yytext);return(INS_BRN);}
BLBC		{ Opc= OPC32_BLBC;	it(yytext);return(INS_BRN);}
BLBS		{ Opc= OPC32_BLBS;	it(yytext);return(INS_BRN);}
FBEQ		{ Opc= OPC32_FBEQ;	it(yytext);return(INS_BRN);}
FBNE		{ Opc= OPC32_FBNE;	it(yytext);return(INS_BRN);}
BEQ		{ Opc= OPC32_BEQ;	it(yytext);return(INS_BRN);}
BNE		{ Opc= OPC32_BNE;	it(yytext);return(INS_BRN);}
FBLT		{ Opc= OPC32_FBLT;	it(yytext);return(INS_BRN);}
FBGE		{ Opc= OPC32_FBGE;	it(yytext);return(INS_BRN);}
BLT		{ Opc= OPC32_BLT;	it(yytext);return(INS_BRN);}
BGE		{ Opc= OPC32_BGE;	it(yytext);return(INS_BRN);}
FBLE		{ Opc= OPC32_FBLE;	it(yytext);return(INS_BRN);}
FBGT		{ Opc= OPC32_FBGT;	it(yytext);return(INS_BRN);}
BLE		{ Opc= OPC32_BLE;	it(yytext);return(INS_BRN);}
BGT		{ Opc= OPC32_BGT;	it(yytext);return(INS_BRN);}

CPYS		{ Opc= OPC32_CPYS;	it(yytext);return(INS_FOP);}
CPYSN		{ Opc= OPC32_CPYSN;	it(yytext);return(INS_FOP);}
CPYSE		{ Opc= OPC32_CPYSE;	it(yytext);return(INS_FOP);}
CPYSEE		{ Opc= OPC32_CPYSEE;	it(yytext);return(INS_FOP);}

WR_FPCTL	{ Opc= OPC32_WR_FPCTL;	it(yytext);return(INS_FOP);}
RD_FPCTL	{ Opc= OPC32_RD_FPCTL;	it(yytext);return(INS_FOP);}
MT_FPCR		{ Opc= OPC32_WR_FPCTL;	it(yytext);return(INS_FOP);}
MF_FPCR		{ Opc= OPC32_RD_FPCTL;	it(yytext);return(INS_FOP);}

CVTLQ		{ Opc= OPC32_CVTLQ;	it(yytext);return(INS_FP2);}
CVTQL		{ Opc= OPC32_CVTQL;	it(yytext);return(INS_FP2);}
CVTQLV		{ Opc= OPC32_CVTQLV;	it(yytext);return(INS_FP2);}
CVTQLSV		{ Opc= OPC32_CVTQLSV;	it(yytext);return(INS_FP2);}

FCMOVEQ			{ Opc= OPC32_FCMOVEQ;	it(yytext);return(INS_FOP);}
FCMOVNE			{ Opc= OPC32_FCMOVNE;	it(yytext);return(INS_FOP);}
FCMOVLT			{ Opc= OPC32_FCMOVLT;	it(yytext);return(INS_FOP);}
FCMOVGE			{ Opc= OPC32_FCMOVGE;	it(yytext);return(INS_FOP);}
FCMOVLE			{ Opc= OPC32_FCMOVLE;	it(yytext);return(INS_FOP);}
FCMOVGT			{ Opc= OPC32_FCMOVGT;	it(yytext);return(INS_FOP);}

ADDS		{ Opc= OPC32_ADDS;	it(yytext);return(INS_FOP);}
ADDSC		{ Opc= OPC32_ADDSC;	it(yytext);return(INS_FOP);}
ADDSM		{ Opc= OPC32_ADDSM;	it(yytext);return(INS_FOP);}
ADDSD		{ Opc= OPC32_ADDSP;	it(yytext);return(INS_FOP);}
ADDSP		{ Opc= OPC32_ADDSP;	it(yytext);return(INS_FOP);}
ADDSU		{ Opc= OPC32_ADDSU;	it(yytext);return(INS_FOP);}
ADDSUC		{ Opc= OPC32_ADDSUC;	it(yytext);return(INS_FOP);}
ADDSUM		{ Opc= OPC32_ADDSUM;	it(yytext);return(INS_FOP);}
ADDSUD		{ Opc= OPC32_ADDSUP;	it(yytext);return(INS_FOP);}
ADDSUP		{ Opc= OPC32_ADDSUP;	it(yytext);return(INS_FOP);}
ADDSSU		{ Opc= OPC32_ADDSSU;	it(yytext);return(INS_FOP);}
ADDSSUC			{ Opc= OPC32_ADDSSUC;	it(yytext);return(INS_FOP);}
ADDSSUM			{ Opc= OPC32_ADDSSUM;	it(yytext);return(INS_FOP);}
ADDSSUD			{ Opc= OPC32_ADDSSUP;	it(yytext);return(INS_FOP);}
ADDSSUP			{ Opc= OPC32_ADDSSUP;	it(yytext);return(INS_FOP);}
ADDSSUI			{ Opc= OPC32_ADDSSUI;	it(yytext);return(INS_FOP);}
ADDSSUIC		{ Opc= OPC32_ADDSSUIC;	it(yytext);return(INS_FOP);}
ADDSSUIM		{ Opc= OPC32_ADDSSUIM;	it(yytext);return(INS_FOP);}
ADDSSUID		{ Opc= OPC32_ADDSSUIP;	it(yytext);return(INS_FOP);}
ADDSSUIP		{ Opc= OPC32_ADDSSUIP;	it(yytext);return(INS_FOP);}
ADDT		{ Opc= OPC32_ADDT;	it(yytext);return(INS_FOP);}
ADDTC		{ Opc= OPC32_ADDTC;	it(yytext);return(INS_FOP);}
ADDTM		{ Opc= OPC32_ADDTM;	it(yytext);return(INS_FOP);}
ADDTD		{ Opc= OPC32_ADDTP;	it(yytext);return(INS_FOP);}
ADDTP		{ Opc= OPC32_ADDTP;	it(yytext);return(INS_FOP);}
ADDTU		{ Opc= OPC32_ADDTU;	it(yytext);return(INS_FOP);}
ADDTUC		{ Opc= OPC32_ADDTUC;	it(yytext);return(INS_FOP);}
ADDTUM		{ Opc= OPC32_ADDTUM;	it(yytext);return(INS_FOP);}
ADDTUD		{ Opc= OPC32_ADDTUP;	it(yytext);return(INS_FOP);}
ADDTUP		{ Opc= OPC32_ADDTUP;	it(yytext);return(INS_FOP);}
ADDTSU		{ Opc= OPC32_ADDTSU;	it(yytext);return(INS_FOP);}
ADDTSUC			{ Opc= OPC32_ADDTSUC;	it(yytext);return(INS_FOP);}
ADDTSUM			{ Opc= OPC32_ADDTSUM;	it(yytext);return(INS_FOP);}
ADDTSUD			{ Opc= OPC32_ADDTSUP;	it(yytext);return(INS_FOP);}
ADDTSUP			{ Opc= OPC32_ADDTSUP;	it(yytext);return(INS_FOP);}
ADDTSUI			{ Opc= OPC32_ADDTSUI;	it(yytext);return(INS_FOP);}
ADDTSUIC		{ Opc= OPC32_ADDTSUIC;	it(yytext);return(INS_FOP);}
ADDTSUIM		{ Opc= OPC32_ADDTSUIM;	it(yytext);return(INS_FOP);}
ADDTSUID		{ Opc= OPC32_ADDTSUIP;	it(yytext);return(INS_FOP);}
ADDTSUIP		{ Opc= OPC32_ADDTSUIP;	it(yytext);return(INS_FOP);}

CMPTEQ		{ Opc= OPC32_CMPTEQ;	it(yytext);return(INS_FOP);}
CMPTEQSU		{ Opc= OPC32_CMPTEQSU;	it(yytext);return(INS_FOP);}
CMPTLT		{ Opc= OPC32_CMPTLT;	it(yytext);return(INS_FOP);}
CMPTLTSU		{ Opc= OPC32_CMPTLTSU;	it(yytext);return(INS_FOP);}
CMPTLE		{ Opc= OPC32_CMPTLE;	it(yytext);return(INS_FOP);}
CMPTLESU		{ Opc= OPC32_CMPTLESU;	it(yytext);return(INS_FOP);}
CMPTUN		{ Opc= OPC32_CMPTUN;	it(yytext);return(INS_FOP);}
CMPTUNSU 	{ Opc= OPC32_CMPTUNSU;	it(yytext);return(INS_FOP);}

CVTQS 	{ Opc= OPC32_CVTQS;	it(yytext);return(INS_FP2);}
CVTQSC 	{ Opc= OPC32_CVTQSC;	it(yytext);return(INS_FP2);}
CVTQSM 	{ Opc= OPC32_CVTQSM;	it(yytext);return(INS_FP2);}
CVTQSD 	{ Opc= OPC32_CVTQSP;	it(yytext);return(INS_FP2);}
CVTQSP 	{ Opc= OPC32_CVTQSP;	it(yytext);return(INS_FP2);}
CVTQSSUI 	{ Opc= OPC32_CVTQSSUI;	it(yytext);return(INS_FP2);}
CVTQSSUIC 	{ Opc= OPC32_CVTQSSUIC;	it(yytext);return(INS_FP2);}
CVTQSSUIM 	{ Opc= OPC32_CVTQSSUIM;	it(yytext);return(INS_FP2);}
CVTQSSUID 	{ Opc= OPC32_CVTQSSUIP;	it(yytext);return(INS_FP2);}
CVTQSSUIP 	{ Opc= OPC32_CVTQSSUIP;	it(yytext);return(INS_FP2);}
CVTQT 	{ Opc= OPC32_CVTQT;	it(yytext);return(INS_FP2);}
CVTQTC 	{ Opc= OPC32_CVTQTC;	it(yytext);return(INS_FP2);}
CVTQTM 	{ Opc= OPC32_CVTQTM;	it(yytext);return(INS_FP2);}
CVTQTD 	{ Opc= OPC32_CVTQTP;	it(yytext);return(INS_FP2);}
CVTQTP 	{ Opc= OPC32_CVTQTP;	it(yytext);return(INS_FP2);}
CVTQTSUI 	{ Opc= OPC32_CVTQTSUI;	it(yytext);return(INS_FP2);}
CVTQTSUIC 	{ Opc= OPC32_CVTQTSUIC;	it(yytext);return(INS_FP2);}
CVTQTSUIM 	{ Opc= OPC32_CVTQTSUIM;	it(yytext);return(INS_FP2);}
CVTQTSUID 	{ Opc= OPC32_CVTQTSUIP;	it(yytext);return(INS_FP2);}
CVTQTSUIP 	{ Opc= OPC32_CVTQTSUIP;	it(yytext);return(INS_FP2);}
CVTST 	{ Opc= OPC32_CVTST;	it(yytext);return(INS_FP2);}
CVTSTS 	{ Opc= OPC32_CVTSTS;	it(yytext);return(INS_FP2);}
CVTTS 	{ Opc= OPC32_CVTTS;	it(yytext);return(INS_FP2);}
CVTTSC 	{ Opc= OPC32_CVTTSC;	it(yytext);return(INS_FP2);}
CVTTSM 	{ Opc= OPC32_CVTTSM;	it(yytext);return(INS_FP2);}
CVTTSD 	{ Opc= OPC32_CVTTSP;	it(yytext);return(INS_FP2);}
CVTTSP 	{ Opc= OPC32_CVTTSP;	it(yytext);return(INS_FP2);}
CVTTSU 	{ Opc= OPC32_CVTTSU;	it(yytext);return(INS_FP2);}
CVTTSUC 	{ Opc= OPC32_CVTTSUC;	it(yytext);return(INS_FP2);}
CVTTSUM 	{ Opc= OPC32_CVTTSUM;	it(yytext);return(INS_FP2);}
CVTTSUD 	{ Opc= OPC32_CVTTSUP;	it(yytext);return(INS_FP2);}
CVTTSUP 	{ Opc= OPC32_CVTTSUP;	it(yytext);return(INS_FP2);}
CVTTSSU 	{ Opc= OPC32_CVTTSSU;	it(yytext);return(INS_FP2);}
CVTTSSUC 	{ Opc= OPC32_CVTTSSUC;	it(yytext);return(INS_FP2);}
CVTTSSUM 	{ Opc= OPC32_CVTTSSUM;	it(yytext);return(INS_FP2);}
CVTTSSUD 	{ Opc= OPC32_CVTTSSUP;	it(yytext);return(INS_FP2);}
CVTTSSUP 	{ Opc= OPC32_CVTTSSUP;	it(yytext);return(INS_FP2);}
CVTTSSUI 	{ Opc= OPC32_CVTTSSUI;	it(yytext);return(INS_FP2);}
CVTTSSUIC 	{ Opc= OPC32_CVTTSSUIC;	it(yytext);return(INS_FP2);}
CVTTSSUIM 	{ Opc= OPC32_CVTTSSUIM;	it(yytext);return(INS_FP2);}
CVTTSSUID 	{ Opc= OPC32_CVTTSSUIP;	it(yytext);return(INS_FP2);}
CVTTSSUIP 	{ Opc= OPC32_CVTTSSUIP;	it(yytext);return(INS_FP2);}

DIVS 	{ Opc= OPC32_DIVS;	it(yytext);return(INS_FOP);}
DIVSC 	{ Opc= OPC32_DIVSC;	it(yytext);return(INS_FOP);}
DIVSM 	{ Opc= OPC32_DIVSM;	it(yytext);return(INS_FOP);}
DIVSD 	{ Opc= OPC32_DIVSP;	it(yytext);return(INS_FOP);}
DIVSP 	{ Opc= OPC32_DIVSP;	it(yytext);return(INS_FOP);}
DIVSU 	{ Opc= OPC32_DIVSU;	it(yytext);return(INS_FOP);}
DIVSUC 	{ Opc= OPC32_DIVSUC;	it(yytext);return(INS_FOP);}
DIVSUM 	{ Opc= OPC32_DIVSUM;	it(yytext);return(INS_FOP);}
DIVSUD 	{ Opc= OPC32_DIVSUP;	it(yytext);return(INS_FOP);}
DIVSUP 	{ Opc= OPC32_DIVSUP;	it(yytext);return(INS_FOP);}
DIVSSU 	{ Opc= OPC32_DIVSSU;	it(yytext);return(INS_FOP);}
DIVSSUC 	{ Opc= OPC32_DIVSSUC;	it(yytext);return(INS_FOP);}
DIVSSUM 	{ Opc= OPC32_DIVSSUM;	it(yytext);return(INS_FOP);}
DIVSSUD 	{ Opc= OPC32_DIVSSUP;	it(yytext);return(INS_FOP);}
DIVSSUP 	{ Opc= OPC32_DIVSSUP;	it(yytext);return(INS_FOP);}
DIVSSUI 	{ Opc= OPC32_DIVSSUI;	it(yytext);return(INS_FOP);}
DIVSSUIC 	{ Opc= OPC32_DIVSSUIC;	it(yytext);return(INS_FOP);}
DIVSSUIM 	{ Opc= OPC32_DIVSSUIM;	it(yytext);return(INS_FOP);}
DIVSSUID 	{ Opc= OPC32_DIVSSUIP;	it(yytext);return(INS_FOP);}
DIVSSUIP 	{ Opc= OPC32_DIVSSUIP;	it(yytext);return(INS_FOP);}
DIVT 	{ Opc= OPC32_DIVT;	it(yytext);return(INS_FOP);}
DIVTC 	{ Opc= OPC32_DIVTC;	it(yytext);return(INS_FOP);}
DIVTM 	{ Opc= OPC32_DIVTM;	it(yytext);return(INS_FOP);}
DIVTD 	{ Opc= OPC32_DIVTP;	it(yytext);return(INS_FOP);}
DIVTP 	{ Opc= OPC32_DIVTP;	it(yytext);return(INS_FOP);}
DIVTU 	{ Opc= OPC32_DIVTU;	it(yytext);return(INS_FOP);}
DIVTUC 	{ Opc= OPC32_DIVTUC;	it(yytext);return(INS_FOP);}
DIVTUM 	{ Opc= OPC32_DIVTUM;	it(yytext);return(INS_FOP);}
DIVTUD 	{ Opc= OPC32_DIVTUP;	it(yytext);return(INS_FOP);}
DIVTUP 	{ Opc= OPC32_DIVTUP;	it(yytext);return(INS_FOP);}
DIVTSU 	{ Opc= OPC32_DIVTSU;	it(yytext);return(INS_FOP);}
DIVTSUC 	{ Opc= OPC32_DIVTSUC;	it(yytext);return(INS_FOP);}
DIVTSUM 	{ Opc= OPC32_DIVTSUM;	it(yytext);return(INS_FOP);}
DIVTSUD 	{ Opc= OPC32_DIVTSUP;	it(yytext);return(INS_FOP);}
DIVTSUP 	{ Opc= OPC32_DIVTSUP;	it(yytext);return(INS_FOP);}
DIVTSUI 	{ Opc= OPC32_DIVTSUI;	it(yytext);return(INS_FOP);}
DIVTSUIC 	{ Opc= OPC32_DIVTSUIC;	it(yytext);return(INS_FOP);}
DIVTSUIM 	{ Opc= OPC32_DIVTSUIM;	it(yytext);return(INS_FOP);}
DIVTSUID 	{ Opc= OPC32_DIVTSUIP;	it(yytext);return(INS_FOP);}
DIVTSUIP 	{ Opc= OPC32_DIVTSUIP;	it(yytext);return(INS_FOP);}
MULS 	{ Opc= OPC32_MULS;	it(yytext);return(INS_FOP);}
MULSC 	{ Opc= OPC32_MULSC;	it(yytext);return(INS_FOP);}
MULSM 	{ Opc= OPC32_MULSM;	it(yytext);return(INS_FOP);}
MULSD 	{ Opc= OPC32_MULSP;	it(yytext);return(INS_FOP);}
MULSP 	{ Opc= OPC32_MULSP;	it(yytext);return(INS_FOP);}
MULSU 	{ Opc= OPC32_MULSU;	it(yytext);return(INS_FOP);}
MULSUC 	{ Opc= OPC32_MULSUC;	it(yytext);return(INS_FOP);}
MULSUM 	{ Opc= OPC32_MULSUM;	it(yytext);return(INS_FOP);}
MULSUD 	{ Opc= OPC32_MULSUP;	it(yytext);return(INS_FOP);}
MULSUP 	{ Opc= OPC32_MULSUP;	it(yytext);return(INS_FOP);}
MULSSU 	{ Opc= OPC32_MULSSU;	it(yytext);return(INS_FOP);}
MULSSUC 	{ Opc= OPC32_MULSSUC;	it(yytext);return(INS_FOP);}
MULSSUM 	{ Opc= OPC32_MULSSUM;	it(yytext);return(INS_FOP);}
MULSSUD 	{ Opc= OPC32_MULSSUP;	it(yytext);return(INS_FOP);}
MULSSUP 	{ Opc= OPC32_MULSSUP;	it(yytext);return(INS_FOP);}
MULSSUI 	{ Opc= OPC32_MULSSUI;	it(yytext);return(INS_FOP);}
MULSSUIC 	{ Opc= OPC32_MULSSUIC;	it(yytext);return(INS_FOP);}
MULSSUIM 	{ Opc= OPC32_MULSSUIM;	it(yytext);return(INS_FOP);}
MULSSUID 	{ Opc= OPC32_MULSSUIP;	it(yytext);return(INS_FOP);}
MULSSUIP 	{ Opc= OPC32_MULSSUIP;	it(yytext);return(INS_FOP);}
MULT 	{ Opc= OPC32_MULT;	it(yytext);return(INS_FOP);}
MULTC 	{ Opc= OPC32_MULTC;	it(yytext);return(INS_FOP);}
MULTM 	{ Opc= OPC32_MULTM;	it(yytext);return(INS_FOP);}
MULTD 	{ Opc= OPC32_MULTP;	it(yytext);return(INS_FOP);}
MULTP 	{ Opc= OPC32_MULTP;	it(yytext);return(INS_FOP);}
MULTU 	{ Opc= OPC32_MULTU;	it(yytext);return(INS_FOP);}
MULTUC 	{ Opc= OPC32_MULTUC;	it(yytext);return(INS_FOP);}
MULTUM 	{ Opc= OPC32_MULTUM;	it(yytext);return(INS_FOP);}
MULTUD 	{ Opc= OPC32_MULTUP;	it(yytext);return(INS_FOP);}
MULTUP 	{ Opc= OPC32_MULTUP;	it(yytext);return(INS_FOP);}
MULTSU 	{ Opc= OPC32_MULTSU;	it(yytext);return(INS_FOP);}
MULTSUC 	{ Opc= OPC32_MULTSUC;	it(yytext);return(INS_FOP);}
MULTSUM 	{ Opc= OPC32_MULTSUM;	it(yytext);return(INS_FOP);}
MULTSUD 	{ Opc= OPC32_MULTSUP;	it(yytext);return(INS_FOP);}
MULTSUP 	{ Opc= OPC32_MULTSUP;	it(yytext);return(INS_FOP);}
MULTSUI 	{ Opc= OPC32_MULTSUI;	it(yytext);return(INS_FOP);}
MULTSUIC 	{ Opc= OPC32_MULTSUIC;	it(yytext);return(INS_FOP);}
MULTSUIM 	{ Opc= OPC32_MULTSUIM;	it(yytext);return(INS_FOP);}
MULTSUID 	{ Opc= OPC32_MULTSUIP;	it(yytext);return(INS_FOP);}
MULTSUIP 	{ Opc= OPC32_MULTSUIP;	it(yytext);return(INS_FOP);}
SUBS 	{ Opc= OPC32_SUBS;	it(yytext);return(INS_FOP);}
SUBSC 	{ Opc= OPC32_SUBSC;	it(yytext);return(INS_FOP);}
SUBSM 	{ Opc= OPC32_SUBSM;	it(yytext);return(INS_FOP);}
SUBSD 	{ Opc= OPC32_SUBSP;	it(yytext);return(INS_FOP);}
SUBSP 	{ Opc= OPC32_SUBSP;	it(yytext);return(INS_FOP);}
SUBSU 	{ Opc= OPC32_SUBSU;	it(yytext);return(INS_FOP);}
SUBSUC 	{ Opc= OPC32_SUBSUC;	it(yytext);return(INS_FOP);}
SUBSUM 	{ Opc= OPC32_SUBSUM;	it(yytext);return(INS_FOP);}
SUBSUD 	{ Opc= OPC32_SUBSUP;	it(yytext);return(INS_FOP);}
SUBSUP 	{ Opc= OPC32_SUBSUP;	it(yytext);return(INS_FOP);}
SUBSSU 	{ Opc= OPC32_SUBSSU;	it(yytext);return(INS_FOP);}
SUBSSUC 	{ Opc= OPC32_SUBSSUC;	it(yytext);return(INS_FOP);}
SUBSSUM 	{ Opc= OPC32_SUBSSUM;	it(yytext);return(INS_FOP);}
SUBSSUD 	{ Opc= OPC32_SUBSSUP;	it(yytext);return(INS_FOP);}
SUBSSUP 	{ Opc= OPC32_SUBSSUP;	it(yytext);return(INS_FOP);}
SUBSSUI 	{ Opc= OPC32_SUBSSUI;	it(yytext);return(INS_FOP);}
SUBSSUIC 	{ Opc= OPC32_SUBSSUIC;	it(yytext);return(INS_FOP);}
SUBSSUIM 	{ Opc= OPC32_SUBSSUIM;	it(yytext);return(INS_FOP);}
SUBSSUID 	{ Opc= OPC32_SUBSSUIP;	it(yytext);return(INS_FOP);}
SUBSSUIP 	{ Opc= OPC32_SUBSSUIP;	it(yytext);return(INS_FOP);}
SUBT 	{ Opc= OPC32_SUBT;	it(yytext);return(INS_FOP);}
SUBTC 	{ Opc= OPC32_SUBTC;	it(yytext);return(INS_FOP);}
SUBTM 	{ Opc= OPC32_SUBTM;	it(yytext);return(INS_FOP);}
SUBTD 	{ Opc= OPC32_SUBTP;	it(yytext);return(INS_FOP);}
SUBTP 	{ Opc= OPC32_SUBTP;	it(yytext);return(INS_FOP);}
SUBTU 	{ Opc= OPC32_SUBTU;	it(yytext);return(INS_FOP);}
SUBTUC 	{ Opc= OPC32_SUBTUC;	it(yytext);return(INS_FOP);}
SUBTUM 	{ Opc= OPC32_SUBTUM;	it(yytext);return(INS_FOP);}
SUBTUD 	{ Opc= OPC32_SUBTUP;	it(yytext);return(INS_FOP);}
SUBTUP 	{ Opc= OPC32_SUBTUP;	it(yytext);return(INS_FOP);}
SUBTSU 	{ Opc= OPC32_SUBTSU;	it(yytext);return(INS_FOP);}
SUBTSUC 	{ Opc= OPC32_SUBTSUC;	it(yytext);return(INS_FOP);}
SUBTSUM 	{ Opc= OPC32_SUBTSUM;	it(yytext);return(INS_FOP);}
SUBTSUD 	{ Opc= OPC32_SUBTSUP;	it(yytext);return(INS_FOP);}
SUBTSUP 	{ Opc= OPC32_SUBTSUP;	it(yytext);return(INS_FOP);}
SUBTSUI 	{ Opc= OPC32_SUBTSUI;	it(yytext);return(INS_FOP);}
SUBTSUIC 	{ Opc= OPC32_SUBTSUIC;	it(yytext);return(INS_FOP);}
SUBTSUIM 	{ Opc= OPC32_SUBTSUIM;	it(yytext);return(INS_FOP);}
SUBTSUID 	{ Opc= OPC32_SUBTSUIP;	it(yytext);return(INS_FOP);}
SUBTSUIP 	{ Opc= OPC32_SUBTSUIP;	it(yytext);return(INS_FOP);}

CVTTQ 	{ Opc= OPC32_CVTTQ;	it(yytext);return(INS_FP2);}
CVTTQC 	{ Opc= OPC32_CVTTQC;	it(yytext);return(INS_FP2);}
CVTTQV 	{ Opc= OPC32_CVTTQV;	it(yytext);return(INS_FP2);}
CVTTQVC 	{ Opc= OPC32_CVTTQVC;	it(yytext);return(INS_FP2);}
CVTTQSV 	{ Opc= OPC32_CVTTQSV;	it(yytext);return(INS_FP2);}
CVTTQSVC 	{ Opc= OPC32_CVTTQSVC;	it(yytext);return(INS_FP2);}
CVTTQSVI 	{ Opc= OPC32_CVTTQSVI;	it(yytext);return(INS_FP2);}
CVTTQSVIC 	{ Opc= OPC32_CVTTQSVIC;	it(yytext);return(INS_FP2);}
CVTTQD 	{ Opc= OPC32_CVTTQD;	it(yytext);return(INS_FP2);}
CVTTQVD 	{ Opc= OPC32_CVTTQVD;	it(yytext);return(INS_FP2);}
CVTTQSVD 	{ Opc= OPC32_CVTTQSVD;	it(yytext);return(INS_FP2);}
CVTTQSVID 	{ Opc= OPC32_CVTTQSVID;	it(yytext);return(INS_FP2);}
CVTTQP 	{ Opc= OPC32_CVTTQD;	it(yytext);return(INS_FP2);}
CVTTQVP 	{ Opc= OPC32_CVTTQVD;	it(yytext);return(INS_FP2);}
CVTTQSVP 	{ Opc= OPC32_CVTTQSVD;	it(yytext);return(INS_FP2);}
CVTTQSVIP 	{ Opc= OPC32_CVTTQSVID;	it(yytext);return(INS_FP2);}
CVTTQM 	{ Opc= OPC32_CVTTQM;	it(yytext);return(INS_FP2);}
CVTTQVM 	{ Opc= OPC32_CVTTQVM;	it(yytext);return(INS_FP2);}
CVTTQSVM 	{ Opc= OPC32_CVTTQSVM;	it(yytext);return(INS_FP2);}
CVTTQSVIM 	{ Opc= OPC32_CVTTQSVIM;	it(yytext);return(INS_FP2);}

ADDF 	{ Opc= OPC32_ADDF;	it(yytext);return(INS_FOP);}
ADDFC 	{ Opc= OPC32_ADDFC;	it(yytext);return(INS_FOP);}
ADDFU 	{ Opc= OPC32_ADDFU;	it(yytext);return(INS_FOP);}
ADDFUC 	{ Opc= OPC32_ADDFUC;	it(yytext);return(INS_FOP);}
ADDFS 	{ Opc= OPC32_ADDFS;	it(yytext);return(INS_FOP);}
ADDFSC 	{ Opc= OPC32_ADDFSC;	it(yytext);return(INS_FOP);}
ADDFSU 	{ Opc= OPC32_ADDFSU;	it(yytext);return(INS_FOP);}
ADDFSUC 	{ Opc= OPC32_ADDFSUC;	it(yytext);return(INS_FOP);}
ADDG 	{ Opc= OPC32_ADDG;	it(yytext);return(INS_FOP);}
ADDGC 	{ Opc= OPC32_ADDGC;	it(yytext);return(INS_FOP);}
ADDGU 	{ Opc= OPC32_ADDGU;	it(yytext);return(INS_FOP);}
ADDGUC 	{ Opc= OPC32_ADDGUC;	it(yytext);return(INS_FOP);}
ADDGS 	{ Opc= OPC32_ADDGS;	it(yytext);return(INS_FOP);}
ADDGSC 	{ Opc= OPC32_ADDGSC;	it(yytext);return(INS_FOP);}
ADDGSU 	{ Opc= OPC32_ADDGSU;	it(yytext);return(INS_FOP);}
ADDGSUC 	{ Opc= OPC32_ADDGSUC;	it(yytext);return(INS_FOP);}

CMPGEQ		{ Opc= OPC32_CMPGEQ;	it(yytext);return(INS_FOP);}
CMPGLT		{ Opc= OPC32_CMPGLT;	it(yytext);return(INS_FOP);}
CMPGLE		{ Opc= OPC32_CMPGLE;	it(yytext);return(INS_FOP);}
CMPGEQS 	{ Opc= OPC32_CMPGEQS;	it(yytext);return(INS_FOP);}
CMPGLTS 	{ Opc= OPC32_CMPGLTS;	it(yytext);return(INS_FOP);}
CMPGLES 	{ Opc= OPC32_CMPGLES;	it(yytext);return(INS_FOP);}

CVTDG 	{ Opc= OPC32_CVTDG;	it(yytext);return(INS_FP2);}
CVTDGC 	{ Opc= OPC32_CVTDGC;	it(yytext);return(INS_FP2);}
CVTDGU 	{ Opc= OPC32_CVTDGU;	it(yytext);return(INS_FP2);}
CVTDGUC 	{ Opc= OPC32_CVTDGUC;	it(yytext);return(INS_FP2);}
CVTDGS 	{ Opc= OPC32_CVTDGS;	it(yytext);return(INS_FP2);}
CVTDGSC 	{ Opc= OPC32_CVTDGSC;	it(yytext);return(INS_FP2);}
CVTDGSU 	{ Opc= OPC32_CVTDGSU;	it(yytext);return(INS_FP2);}
CVTDGSUC 	{ Opc= OPC32_CVTDGSUC;	it(yytext);return(INS_FP2);}
CVTGD 	{ Opc= OPC32_CVTGD;	it(yytext);return(INS_FP2);}
CVTGDC 	{ Opc= OPC32_CVTGDC;	it(yytext);return(INS_FP2);}
CVTGDU 	{ Opc= OPC32_CVTGDU;	it(yytext);return(INS_FP2);}
CVTGDUC 	{ Opc= OPC32_CVTGDUC;	it(yytext);return(INS_FP2);}
CVTGDS 	{ Opc= OPC32_CVTGDS;	it(yytext);return(INS_FP2);}
CVTGDSC 	{ Opc= OPC32_CVTGDSC;	it(yytext);return(INS_FP2);}
CVTGDSU 	{ Opc= OPC32_CVTGDSU;	it(yytext);return(INS_FP2);}
CVTGDSUC 	{ Opc= OPC32_CVTGDSUC;	it(yytext);return(INS_FP2);}

CVTGF 	{ Opc= OPC32_CVTGF;	it(yytext);return(INS_FP2);}
CVTGFC 	{ Opc= OPC32_CVTGFC;	it(yytext);return(INS_FP2);}
CVTGFU 	{ Opc= OPC32_CVTGFU;	it(yytext);return(INS_FP2);}
CVTGFUC 	{ Opc= OPC32_CVTGFUC;	it(yytext);return(INS_FP2);}
CVTGFS 	{ Opc= OPC32_CVTGFS;	it(yytext);return(INS_FP2);}
CVTGFSC 	{ Opc= OPC32_CVTGFSC;	it(yytext);return(INS_FP2);}
CVTGFSU 	{ Opc= OPC32_CVTGFSU;	it(yytext);return(INS_FP2);}
CVTGFSUC 	{ Opc= OPC32_CVTGFSUC;	it(yytext);return(INS_FP2);}

CVTQF 	{ Opc= OPC32_CVTQF;	it(yytext);return(INS_FP2);}
CVTQFC 	{ Opc= OPC32_CVTQFC;	it(yytext);return(INS_FP2);}
CVTQFS 	{ Opc= OPC32_CVTQFS;	it(yytext);return(INS_FP2);}
CVTQFSC 	{ Opc= OPC32_CVTQFSC;	it(yytext);return(INS_FP2);}
CVTQG 	{ Opc= OPC32_CVTQG;	it(yytext);return(INS_FP2);}
CVTQGC 	{ Opc= OPC32_CVTQGC;	it(yytext);return(INS_FP2);}
CVTQGS 	{ Opc= OPC32_CVTQGS;	it(yytext);return(INS_FP2);}
CVTQGSC 	{ Opc= OPC32_CVTQGSC;	it(yytext);return(INS_FP2);}

DIVF 	{ Opc= OPC32_DIVF;	it(yytext);return(INS_FOP);}
DIVFC 	{ Opc= OPC32_DIVFC;	it(yytext);return(INS_FOP);}
DIVFU 	{ Opc= OPC32_DIVFU;	it(yytext);return(INS_FOP);}
DIVFUC 	{ Opc= OPC32_DIVFUC;	it(yytext);return(INS_FOP);}
DIVFS 	{ Opc= OPC32_DIVFS;	it(yytext);return(INS_FOP);}
DIVFSC 	{ Opc= OPC32_DIVFSC;	it(yytext);return(INS_FOP);}
DIVFSU 	{ Opc= OPC32_DIVFSU;	it(yytext);return(INS_FOP);}
DIVFSUC 	{ Opc= OPC32_DIVFSUC;	it(yytext);return(INS_FOP);}
DIVG 	{ Opc= OPC32_DIVG;	it(yytext);return(INS_FOP);}
DIVGC 	{ Opc= OPC32_DIVGC;	it(yytext);return(INS_FOP);}
DIVGU 	{ Opc= OPC32_DIVGU;	it(yytext);return(INS_FOP);}
DIVGUC 	{ Opc= OPC32_DIVGUC;	it(yytext);return(INS_FOP);}
DIVGS 	{ Opc= OPC32_DIVGS;	it(yytext);return(INS_FOP);}
DIVGSC 	{ Opc= OPC32_DIVGSC;	it(yytext);return(INS_FOP);}
DIVGSU 	{ Opc= OPC32_DIVGSU;	it(yytext);return(INS_FOP);}
DIVGSUC 	{ Opc= OPC32_DIVGSUC;	it(yytext);return(INS_FOP);}

MULF 	{ Opc= OPC32_MULF;	it(yytext);return(INS_FOP);}
MULFC 	{ Opc= OPC32_MULFC;	it(yytext);return(INS_FOP);}
MULFU 	{ Opc= OPC32_MULFU;	it(yytext);return(INS_FOP);}
MULFUC 	{ Opc= OPC32_MULFUC;	it(yytext);return(INS_FOP);}
MULFS 	{ Opc= OPC32_MULFS;	it(yytext);return(INS_FOP);}
MULFSC 	{ Opc= OPC32_MULFSC;	it(yytext);return(INS_FOP);}
MULFSU 	{ Opc= OPC32_MULFSU;	it(yytext);return(INS_FOP);}
MULFSUC 	{ Opc= OPC32_MULFSUC;	it(yytext);return(INS_FOP);}
MULG 	{ Opc= OPC32_MULG;	it(yytext);return(INS_FOP);}
MULGC 	{ Opc= OPC32_MULGC;	it(yytext);return(INS_FOP);}
MULGU 	{ Opc= OPC32_MULGU;	it(yytext);return(INS_FOP);}
MULGUC 	{ Opc= OPC32_MULGUC;	it(yytext);return(INS_FOP);}
MULGS 	{ Opc= OPC32_MULGS;	it(yytext);return(INS_FOP);}
MULGSC 	{ Opc= OPC32_MULGSC;	it(yytext);return(INS_FOP);}
MULGSU 	{ Opc= OPC32_MULGSU;	it(yytext);return(INS_FOP);}
MULGSUC 	{ Opc= OPC32_MULGSUC;	it(yytext);return(INS_FOP);}

SUBF 	{ Opc= OPC32_SUBF;	it(yytext);return(INS_FOP);}
SUBFC 	{ Opc= OPC32_SUBFC;	it(yytext);return(INS_FOP);}
SUBFU 	{ Opc= OPC32_SUBFU;	it(yytext);return(INS_FOP);}
SUBFUC 	{ Opc= OPC32_SUBFUC;	it(yytext);return(INS_FOP);}
SUBFS 	{ Opc= OPC32_SUBFS;	it(yytext);return(INS_FOP);}
SUBFSC 	{ Opc= OPC32_SUBFSC;	it(yytext);return(INS_FOP);}
SUBFSU 	{ Opc= OPC32_SUBFSU;	it(yytext);return(INS_FOP);}
SUBFSUC 	{ Opc= OPC32_SUBFSUC;	it(yytext);return(INS_FOP);}
SUBG		{ Opc= OPC32_SUBG;	it(yytext);return(INS_FOP);}
SUBGC		{ Opc= OPC32_SUBGC;	it(yytext);return(INS_FOP);}
SUBGU		{ Opc= OPC32_SUBGU;	it(yytext);return(INS_FOP);}
SUBGUC		{ Opc= OPC32_SUBGUC;	it(yytext);return(INS_FOP);}
SUBGS		{ Opc= OPC32_SUBGS;	it(yytext);return(INS_FOP);}
SUBGSC		{ Opc= OPC32_SUBGSC;	it(yytext);return(INS_FOP);}
SUBGSU		{ Opc= OPC32_SUBGSU;	it(yytext);return(INS_FOP);}
SUBGSUC		{ Opc= OPC32_SUBGSUC;	it(yytext);return(INS_FOP);}

CVTGQ		{ Opc= OPC32_CVTGQ;	it(yytext);return(INS_FP2);}
CVTGQC		{ Opc= OPC32_CVTGQC;	it(yytext);return(INS_FP2);}
CVTGQV		{ Opc= OPC32_CVTGQV;	it(yytext);return(INS_FP2);}
CVTGQVC 	{ Opc= OPC32_CVTGQVC;	it(yytext);return(INS_FP2);}
CVTGQS		{ Opc= OPC32_CVTGQS;	it(yytext);return(INS_FP2);}
CVTGQSC 	{ Opc= OPC32_CVTGQSC;	it(yytext);return(INS_FP2);}
CVTGQSV 	{ Opc= OPC32_CVTGQSV;	it(yytext);return(INS_FP2);}
CVTGQSVC 	{ Opc= OPC32_CVTGQSVC;	it(yytext);return(INS_FP2);}

MB		{ Opc= OPC32_MB;	it(yytext);return(INS_MIS);}
TRAPB		{ Opc= OPC32_DRAINT;	it(yytext);return(INS_MIS);}
DRAINT		{ Opc= OPC32_DRAINT;	it(yytext);return(INS_MIS);}

RCC		{ Opc= OPC32_RCC;	it(yytext);return(INS_M1A);}
RPCC		{ Opc= OPC32_RCC;	it(yytext);return(INS_M1A);}
RC		{ Opc= OPC32_RC;	it(yytext);return(INS_M1A);}
RS		{ Opc= OPC32_RS;	it(yytext);return(INS_M1A);}

FETCH		{ Opc= OPC32_FETCH;	it(yytext);return(INS_M1B);}
FETCH_M		{ Opc= OPC32_FETCH_M;	it(yytext);return(INS_M1B);}

HW_REI		{ Opc= OPC32_HW_REI; it(yytext);return(INS_MIS);}

HW_MFPR		{ Opc= OPC32_HW_MFPR; it(yytext);return(INS_PAL);}
HW_MTPR		{ Opc= OPC32_HW_MTPR; it(yytext);return(INS_PAL);}
MT		{ Opc= OPC32_MT; it(yytext);return(INS_PAL);}
MF		{ Opc= OPC32_MF; it(yytext);return(INS_PAL);}

HW_LD		{ Opc= OPC32_HW_LD; it(yytext);return(INS_HWM);}
HW_ST		{ Opc= OPC32_HW_ST; it(yytext);return(INS_HWM);}
LDLP		{ Opc= OPC32_LDL_P; it(yytext);return(INS_HWM);}
LDLA		{ Opc= OPC32_LDL_A; it(yytext);return(INS_HWM);}
LDLW		{ Opc= OPC32_LDL_W; it(yytext);return(INS_HWM);}
LDLAW		{ Opc= OPC32_LDL_AW; it(yytext);return(INS_HWM);}
LDLPL		{ Opc= OPC32_LDL_PL; it(yytext);return(INS_HWM);}
LDLV		{ Opc= OPC32_LDL_V; it(yytext);return(INS_HWM);}
LDQP		{ Opc= OPC32_LDQ_P; it(yytext);return(INS_HWM);}
LDQA		{ Opc= OPC32_LDQ_A; it(yytext);return(INS_HWM);}
LDQW		{ Opc= OPC32_LDQ_W; it(yytext);return(INS_HWM);}
LDQAW		{ Opc= OPC32_LDQ_AW; it(yytext);return(INS_HWM);}
LDQPL		{ Opc= OPC32_LDQ_PL; it(yytext);return(INS_HWM);}
LDQV		{ Opc= OPC32_LDQ_V; it(yytext);return(INS_HWM);}
STLP		{ Opc= OPC32_STL_P; it(yytext);return(INS_HWM);}
STLA		{ Opc= OPC32_STL_A; it(yytext);return(INS_HWM);}
STLPC		{ Opc= OPC32_STL_PC; it(yytext);return(INS_HWM);}
STLV		{ Opc= OPC32_STL_V; it(yytext);return(INS_HWM);}
STQP		{ Opc= OPC32_STQ_P; it(yytext);return(INS_HWM);}
STQA		{ Opc= OPC32_STQ_A; it(yytext);return(INS_HWM);}
STQPC		{ Opc= OPC32_STQ_PC; it(yytext);return(INS_HWM);}
STQV		{ Opc= OPC32_STQ_V; it(yytext);return(INS_HWM);}

HALT		{ Opc= 0x0; it(yytext);return(INS_MIS);}

{COMT}		{it(yytext);return(COMMENT);}
{WS}		{ }
[\n]		{ return(NL);}
{SYMBOL}	{ it(yytext); strcpy(Sym,yytext);return(SYMB);}  
[\\]		{ it(yytext);return(XOR);}
[!]		{ it(yytext);return(OR);}
[.]		{ it(yytext);return(DOT);}
[:]		{ it(yytext);return(CL);}
[,]		{ it(yytext);return(CA);}
[(]		{ it(yytext);return(LP);}
[)]		{ it(yytext);return(RP);}
[#]		{ it(yytext);return(PD);}
.		{ it(yytext); return(yytext[0]);}
<<EOF>>		{ return(EOSC); }
%%
/*****************************************************************************/
scan64h(s)
char *s;
{
int  len;
char c[15];
 len = strlen(s);
 uppercase(s);
 R[0]=R[1]=0x0;
 if(len > 10)
  {
   sscanf(&s[len-8],"%x",&R[0]);
   strncpy(c,s,(len-8));
   c[len-8]='\0';
   sscanf(c,"^X%x",&R[1]);
/**printf("64bit:[%s]--> %08X %08X\n",s,R[1],R[0]);  **/
   return(IM64);
  }
 else
  {
   sscanf(s,"^X%x",&R[0]);
   return(IMMED);
  };
}
/*****************************************************************************/
